Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 14228 | Accepted: 8023 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
题目大意:给定两个数,求出从一个数到另一个数所经过的所有素数,经过多少次的变换,可以变成另一个数。
思路:BFS搜所,先将所有的素数打表,然后枚举一个数的4位,分别用0-9来替换。
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<queue>
#define LL long long
bool vis[10000],fl[10000],bj;
int su[5000];
int tep[10000];
int num[4];
struct node
{
int x,ans;
};
using namespace std;
int n,m,e;
void BFS(int s)
{
queue<node >q;
while(!q.empty()) q.pop();
int x,y;
node f1,f2;
f1.x=s;f1.ans=0;
fl[f1.x]=true;
q.push(f1);
while(!q.empty())
{
f1=q.front();
q.pop();
if(f1.x==e)
{
bj=true;
printf("%d\n",f1.ans);
return ;
}
for(int i=0;i<4;i++)
{
num[0]=f1.x%10,num[1]=f1.x/10%10,num[2]=f1.x/100%10,num[3]=f1.x/1000;
for(int j=0;j<=9;j++)
{
num[i]=j;
f2.x=num[3]*1000+num[2]*100+num[1]*10+num[0];
if(!vis[f2.x]&&!fl[f2.x]&&f2.x>1000&&f2.x<10000)
{
fl[f2.x]=true;
f2.ans=f1.ans+1;
q.push(f2);
}
}
}
}
}
int main()
{
int i,j,k,s,sum=0;
memset(vis,false,sizeof(vis));
for(i=2;i<=10000;i++)
{
if(!vis[i])
su[sum++]=i;
for(int j=0;j<sum&&su[j]*i<10000;j++)
{
vis[su[j]*i ]=true;
if(i%su[j]==0)
break;
}
}
while(~scanf("%d",&n)&&n)
{
while(n--)
{
bj=false;
scanf("%d%d",&s,&e);
memset(fl,false,sizeof(fl));
BFS(s);
if(!bj)
printf("Impossible\n");
}
}
return 0;
}